﻿@page "/booklist"
@inject HttpClient httpClient
@inject IDialogService _dialogService;

<MudTable Items="@Books" Dense="@dense" Hover="@hover" Bordered="@bordered" Striped="@striped" Filter="new Func<Book,bool>(FilterFunc)" @bind-SelectedItem="selectedItem" Loading="@_loading" LoadingProgressColor="Color.Primary" RowsPerPage="25">
    <ToolBarContent>
        <MudText Typo="Typo.h6">Book List</MudText>
        <MudSpacer />
        <MudTextField @bind-Value="searchString" Placeholder="Search" Adornment="Adornment.Start" AdornmentIcon="@Icons.Material.Filled.Search" IconSize="Size.Medium" Class="mt-0"></MudTextField>
        <MudFab Color="Color.Primary" Icon="@Icons.Material.Filled.Add" Size="Size.Medium" IconSize="Size.Small" Class="ma-2" @onclick="(e => Create())" />
    </ToolBarContent>
    <HeaderContent>
        <MudTh>BookId</MudTh>
        <MudTh>Title</MudTh>
        <MudTh>Author</MudTh>
        <MudTh>Action</MudTh>
    </HeaderContent>
    <RowTemplate>
        <MudTd DataLabel="BookId">@context.BookId</MudTd>
        <MudTd DataLabel="Title">@context.Title</MudTd>
        <MudTd DataLabel="Author">@context.Author</MudTd>
        <MudTh DataLabel="Action">
            <MudIconButton OnClick="@(e => Update(@context.BookId))" Icon="@Icons.Material.Filled.Edit" Color="Color.Primary"></MudIconButton>
            <MudIconButton OnClick="@(e => Delete(@context.BookId))" Icon="@Icons.Material.Filled.Delete" Color="Color.Primary"></MudIconButton>
        </MudTh>
    </RowTemplate>
    <PagerContent>
        <MudTablePager />
    </PagerContent>
</MudTable>
<div class="d-flex flex-wrap mt-4">
    <MudSwitch @bind-Checked="@hover" Color="Color.Primary">Hover</MudSwitch>
    <MudSwitch @bind-Checked="@dense" Color="Color.Secondary">Dense</MudSwitch>
    <MudSwitch @bind-Checked="@striped" Color="Color.Tertiary">Striped</MudSwitch>
    <MudSwitch @bind-Checked="@bordered" Color="Color.Warning">Bordered</MudSwitch>
    <MudSpacer />
    <MudText Inline="true" Class="align-self-center" Style="min-width:200px;">Selected: @selectedItem?.Title</MudText>
</div>

@code {
    private bool dense = true;
    private bool hover = true;
    private bool striped = true;
    private bool bordered = false;
    private string searchString = "";
    private bool _loading;
    private Book selectedItem = null;
    private HashSet<Book> selectedItems = new HashSet<Book>();

    private IEnumerable<Book> Books = new List<Book>();

    protected override async Task OnInitializedAsync()
    {
        _loading = true;
        Books = await httpClient.GetFromJsonAsync<IEnumerable<Book>>("api/Books");
        _loading = false;
    }

    private bool FilterFunc(Book element)
    {
        if (string.IsNullOrWhiteSpace(searchString))
            return true;
        if (element.BookId.ToString().Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        if (element.Title.Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        if (element.Author.Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        return false;
    }

    private async Task Create()
    {
        var parameters = new DialogParameters();
        parameters.Add("Book", new Book());
        var dialog = await _dialogService.Show<BookUpsert>("Create A Book", parameters).Result;

        if (dialog.Data != null)
        {
            Book newBook = dialog.Data as Book;
            await httpClient.PostAsJsonAsync<Book>("api/Books", newBook);
            await OnInitializedAsync();
        }
    }

    private async Task Update(int bookId)
    {
        Book book = await httpClient.GetFromJsonAsync<Book>($"api/Books/{bookId}");

        var parameters = new DialogParameters();
        parameters.Add("Book", book);
        var dialog = await _dialogService.Show<BookUpsert>("Update A Book", parameters).Result;

        if (dialog.Data != null)
        {
            Book updateBook = dialog.Data as Book;
            await httpClient.PutAsJsonAsync<Book>($"api/Books/{bookId}", updateBook);
            await OnInitializedAsync();
        }
    }

    private async Task Delete(int bookId)
    {
        bool? result = await _dialogService.ShowMessageBox("Warning",
                                                           "削除してもよろしいですか？",
                                                           yesText: "Delete",
                                                           cancelText: "Cancel");
        if (result != null && result == true)
        {
            await httpClient.DeleteAsync($"api/Books/{bookId}");
            await OnInitializedAsync();
        }
    }
}